'******************************************************************************
'                             PWM2LED.BAS                                       
'                              30.12.2010                                                
'******************************************************************************
'                      
'Es werden 2 LEDs mittels PWM angesteuert (z.B. kalt- und warmwei). Die Grund-
'helligkeit wird ber einen 4-Bit-Dipschalter (RC0..RC3) eingestellt. Die Farb-
'mischung ber den Adwandler Kanal 1 (nur beim iL-TROLL, bei PICs ohne AD-Wandler
'kann man dies ber einen zweiten 4-Bit-Dipschalter realisieren; der Code ist dann
'entsprechend anzupassen.
'
'$if, $ELSE und $endif dienen zur bedingten Compilierung
'

         define troll=1 as const       '1 = iL-TROLL, 0 fr den 16F628A

$if troll
         DEFINE DEVICE iL_Troll
'         $debug                        'ggf. Testfunktion einschalten
$else

         $list /M_obj                  'falls mit dem PicKit2 programmiert wird
         $list obj2hex                 'dito
  
         define device 16F628A         'Prozessorauswahl
         config ircp_osc               'interner 4 MHz RC-Oszillator anwhlen
         config wdt_off                'Watchdog ausschalten
         config cmcfg7                 'Komparatoren ausschalten
         config protect_on             'Ausleseschutz einschalten
         config mclr_int               'MCLR-Pin ist IO-Pin, MCLR-Funktion intern
         
         xtal 4                        '4 MHz Quarz
           
$endif
 
'Variablendefinitionen
         define counter = auto as byte           'dieser Zhler ist sozusagen die Zeitbasis
         define pwm1 = auto as byte              'hier steht das jeweilige Tastverhltnis
         define pwm2 = auto as byte              'dito Kanal 2
'         define pwm3 = auto as byte             'zum erweitern und experimentieren
         define kanal1 = auto as byte            'Hilfsvariable fr Kanal 1
         define kanal2 = auto as byte            'Hilfsvariable Kanal 2
'         define kanal3 = auto as byte           '
         define count2 = auto as byte            'Zhler fr Grundhelligkeit
         define temp = auto as byte              'Hilfsvariablen
         define temp1 = auto as byte
         define temp2 = auto as byte
         define helligkeit = auto as byte        'Grundhelligkeit
         
'Konstantendefinition
         define led1 = rb,0
         define led2 = rb,1
'         define led3 = rb,2
                   
'Portinitialisierung
$if troll
$else
'         let osccon = $60                        'fr den internen Oszillator z.B. beim 16F88
$endif         
         tris rb,%11111000
'  $troff                                         'Erzeugung von DEBUG-Code ausschalten (Echtzeit)
         let pwm1=0                              'Startwert Kanal 1
         let pwm2=0                              'Startwert Kanal 2
'         let pwm3=0                              'ggf. Startwert Kanal 3
         let kanal1 = 0                          'dito
         let kanal2 = 0
         let count2 = 0
         let Helligkeit = 0
loop:    

         if counter <> 0 then goto loop1         'Helligkeitsinfor nicht zu oft einlesen
'Helligkeit einlesen
         let helligkeit = rc and $f              'Helligkeit wird an RC mit 4 DIP-Schaltern eingestellt
         let helligkeit = helligkeit xor $f      'Bits invertieren, da geschlossen = 0V ist
         
loop1:
         inc counter                             'PWM-Zhler
         inc count2                              'Helligkeitszhler
         if count2 > helligkeit then goto loop3  'Grundhelligkeit bereits erreicht?
         
         let pwm1 = pwm1 + temp1                 'nein, Offsetwert1 addieren
         let pwm2 = pwm2 + temp2                 'nein, Offsetwert2 addieren
loop2:         
        
         if kanal1>counter then set led1 else res led1  'muss LED1 ein oder aus sein?
         if kanal2>counter then set led2 else res led2  'muss LED2 ein oder aus sein
'$troff         
         goto loop                               'Endlosschleife

loop3:                                           'Grundhelligkeit erreicht
'$tron                                            'Erzeugen von DEBUG-Code einschalten
         let kanal1 = pwm1                       'Variablen auf ihre Startwerte zurcksetzen,denn
         let kanal2 = pwm2                       'ein PWM-Zyklus ist jetzt abgelaufen
         let pwm1 = 0                            'die Zahler zurcksetzen
         let pwm2 = 0
         let count2 = 0
'Farbmischung einlesen         
         adinp 0,temp1                           'Farbmischung ber Poti einstellbar
         swap temp1                              'nur 16 Stufen bercksichtigen
         let temp1 = temp1 and 15                'obere Bits unglltig, deshalb auf 0 stellen
         let temp2 = temp1 xor 15                'Kanal 2 ist der Maximalwert abzgl. Kanal 1
         goto loop2
         
          END